#pragma once

#include <memory>
#include <vector>

class INativeDrawingContext;
class AbstractGeometricItem;
using AbstractGeometricItemPtr = std::unique_ptr<AbstractGeometricItem>;

class TriMesh;

class DrawingContext
{
public:
    DrawingContext() = default;

    static std::unique_ptr<DrawingContext> Create();

    void setNativeContext(std::unique_ptr<INativeDrawingContext> context);

    INativeDrawingContext* getNativeContext();

    unsigned getNumItems() const;

    void addDrawable(AbstractGeometricItemPtr item);

    AbstractGeometricItem* getDrawable(unsigned idx) const;

private:
    void updateMesh();

    std::unique_ptr<TriMesh> mMesh;
    std::vector<std::unique_ptr<AbstractGeometricItem> > mItems;
    std::unique_ptr<INativeDrawingContext> mNativeDrawingContext;
};

using DrawingContextPtr = std::unique_ptr<DrawingContext>;
